/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { Platform } from '@angular/cdk/platform';
import { AfterViewInit, ElementRef, EventEmitter, NgZone, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { NzScrollService } from 'ng-zorro-antd/core';
export declare const NZ_AFFIX_DEFAULT_SCROLL_TIME = 20;
export declare class NzAffixComponent implements AfterViewInit, OnChanges, OnDestroy {
    private scrollSrv;
    private doc;
    private ngZone;
    private platform;
    nzTarget: string | Element | Window;
    nzOffsetTop: number | null;
    nzOffsetBottom: number;
    readonly nzChange: EventEmitter<boolean>;
    private timeout;
    private scroll$;
    private readonly events;
    private fixedEl;
    private readonly placeholderNode;
    private affixStyle;
    private placeholderStyle;
    private _offsetTop;
    private _offsetBottom;
    private readonly target;
    constructor(_el: ElementRef, scrollSrv: NzScrollService, doc: any, ngZone: NgZone, platform: Platform);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    getOffset(element: Element, target: Element | Window | undefined): {
        top: number;
        left: number;
        width: number;
        height: number;
    };
    private registerListeners;
    private removeListeners;
    private getTargetRect;
    private genStyle;
    private setAffixStyle;
    private setPlaceholderStyle;
    private syncPlaceholderStyle;
    updatePosition(e: Event): void;
}
